SoMarkerSet(3)

NAME
SoMarkerSet - The SoMarkerSet class displays a set of 2D bitmap markers in 3D.

SYNOPSIS

#include <Inventor/nodes/SoMarkerSet.h>

Inherits SoPointSet.

  Public Types
enum MarkerType { NONE = -1, CROSS_5_5, PLUS_5_5, MINUS_5_5, SLASH_5_5, BACKSLASH_5_5, BAR_5_5, STAR_5_5, Y_5_5, LIGHTNING_5_5, WELL_5_5, CIRCLE_LINE_5_5, SQUARE_LINE_5_5, DIAMOND_LINE_5_5, TRIANGLE_LINE_5_5, RHOMBUS_LINE_5_5, HOURGLASS_LINE_5_5, SATELLITE_LINE_5_5, PINE_TREE_LINE_5_5, CAUTION_LINE_5_5, SHIP_LINE_5_5, CIRCLE_FILLED_5_5, SQUARE_FILLED_5_5, DIAMOND_FILLED_5_5, TRIANGLE_FILLED_5_5, RHOMBUS_FILLED_5_5, HOURGLASS_FILLED_5_5, SATELLITE_FILLED_5_5, PINE_TREE_FILLED_5_5, CAUTION_FILLED_5_5, SHIP_FILLED_5_5, CROSS_7_7, PLUS_7_7, MINUS_7_7, SLASH_7_7, BACKSLASH_7_7, BAR_7_7, STAR_7_7, Y_7_7, LIGHTNING_7_7, WELL_7_7, CIRCLE_LINE_7_7, SQUARE_LINE_7_7, DIAMOND_LINE_7_7, TRIANGLE_LINE_7_7, RHOMBUS_LINE_7_7, HOURGLASS_LINE_7_7, SATELLITE_LINE_7_7, PINE_TREE_LINE_7_7, CAUTION_LINE_7_7, SHIP_LINE_7_7, CIRCLE_FILLED_7_7, SQUARE_FILLED_7_7, DIAMOND_FILLED_7_7, TRIANGLE_FILLED_7_7, RHOMBUS_FILLED_7_7, HOURGLASS_FILLED_7_7, SATELLITE_FILLED_7_7, PINE_TREE_FILLED_7_7, CAUTION_FILLED_7_7, SHIP_FILLED_7_7, CROSS_9_9, PLUS_9_9, MINUS_9_9, SLASH_9_9, BACKSLASH_9_9, BAR_9_9, STAR_9_9, Y_9_9, LIGHTNING_9_9, WELL_9_9, CIRCLE_LINE_9_9, SQUARE_LINE_9_9, DIAMOND_LINE_9_9, TRIANGLE_LINE_9_9, RHOMBUS_LINE_9_9, HOURGLASS_LINE_9_9, SATELLITE_LINE_9_9, PINE_TREE_LINE_9_9, CAUTION_LINE_9_9, SHIP_LINE_9_9, CIRCLE_FILLED_9_9, SQUARE_FILLED_9_9, DIAMOND_FILLED_9_9, TRIANGLE_FILLED_9_9, RHOMBUS_FILLED_9_9, HOURGLASS_FILLED_9_9, SATELLITE_FILLED_9_9, PINE_TREE_FILLED_9_9, CAUTION_FILLED_9_9, SHIP_FILLED_9_9, NUM_MARKERS }
Public Types inherited from SoShape
enum TriangleShape { TRIANGLE_STRIP, TRIANGLE_FAN, TRIANGLES, POLYGON, QUADS, QUAD_STRIP, POINTS, LINES, LINE_STRIP }
Public Types inherited from SoNode
enum NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000, COIN_4_0 = 0x20000 }

  Public Member Functions
virtual SoType getTypeId (void) const
SoMarkerSet (void)
virtual void GLRender (SoGLRenderAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
Public Member Functions inherited from SoPointSet
SoPointSet (void)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
Public Member Functions inherited from SoVertexShape
virtual void notify (SoNotList *nl)
virtual void write (SoWriteAction *action)
Public Member Functions inherited from SoShape
virtual SbBool affectsState (void) const
virtual void rayPick (SoRayPickAction *action)
virtual void callback (SoCallbackAction *action)
const SoBoundingBoxCache * getBoundingBoxCache (void) const
Public Member Functions inherited from SoNode
void setOverride (const SbBool state)
SbBool isOverride (void) const
void setNodeType (const NodeType type)
NodeType getNodeType (void) const
virtual SoNode * copy (SbBool copyconnections=FALSE) const
virtual void doAction (SoAction *action)
virtual void GLRenderBelowPath (SoGLRenderAction *action)
virtual void GLRenderInPath (SoGLRenderAction *action)
virtual void GLRenderOffPath (SoGLRenderAction *action)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void handleEvent (SoHandleEventAction *action)
virtual void pick (SoPickAction *action)
virtual void search (SoSearchAction *action)
virtual void audioRender (SoAudioRenderAction *action)
virtual void grabEventsSetup (void)
virtual void grabEventsCleanup (void)
virtual void startNotify (void)
SbUniqueId getNodeId (void) const
virtual SoChildList * getChildren (void) const
virtual void writeInstance (SoOutput *out)
virtual SoNode * addToCopyDict (void) const
virtual void copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void setToDefaults (void)
SbBool hasDefaultValues (void) const
SbBool fieldsAreEqual (const SoFieldContainer *container) const
void copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool set (const char *const fielddata)
void get (SbString &fielddata)
virtual int getFields (SoFieldList &l) const
virtual int getAllFields (SoFieldList &l) const
virtual SoField * getField (const SbName &name) const
virtual SoField * getEventIn (const SbName &name) const
virtual SoField * getEventOut (const SbName &name) const
SbBool getFieldName (const SoField *const field, SbName &name) const
SbBool enableNotify (const SbBool flag)
SbBool isNotifyEnabled (void) const
SbBool set (const char *fielddata, SoInput *input)
void get (SbString &fielddata, SoOutput *out)
virtual SbBool validateNewFieldValue (SoField *field, void *newval)
virtual void addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool getIsBuiltIn (void) const
virtual void getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void setUserData (void *userdata) const
void * getUserData (void) const
Public Member Functions inherited from SoBase
void ref (void) const
void unref (void) const
void unrefNoDelete (void) const
int32_t getRefCount (void) const
void touch (void)
SbBool isOfType (SoType type) const
Returns TRUE if the type of this object is either of the same type or inherited from type.
virtual SbName getName (void) const
virtual void setName (const SbName &newname)
void addAuditor (void *const auditor, const SoNotRec::Type type)
void removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & getAuditors (void) const
SbBool shouldWrite (void)
void assertAlive (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
static int getNumDefinedMarkers (void)
static void addMarker (int idx, const SbVec2s &size, const unsigned char *bytes, SbBool isLSBFirst=TRUE, SbBool isUpToDown=TRUE)
static SbBool getMarker (int idx, SbVec2s &size, const unsigned char *&bytes, SbBool &isLSBFirst)
static SbBool removeMarker (int idx)
static SbBool isMarkerBitSet (int idx, int bitNumber)
Static Public Member Functions inherited from SoPointSet
static SoType getClassTypeId (void)
static void initClass (void)
Static Public Member Functions inherited from SoNonIndexedShape
static SoType getClassTypeId (void)
static void initClass (void)
Static Public Member Functions inherited from SoVertexShape
static SoType getClassTypeId (void)
static void initClass (void)
Static Public Member Functions inherited from SoShape
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void getScreenSize (SoState *const state, const SbBox3f &boundingbox, SbVec2s &rectsize)
static float getDecimatedComplexity (SoState *state, float complexity)
Static Public Member Functions inherited from SoNode
static uint32_t getCompatibilityTypes (const SoType &nodetype)
static SoType getClassTypeId (void)
static SoNode * getByName (const SbName &name)
static int getByName (const SbName &name, SoNodeList &l)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void initClasses (void)
static SbUniqueId getNextNodeId (void)
static int getActionMethodIndex (const SoType type)
static void getBoundingBoxS (SoAction *action, SoNode *node)
static void GLRenderS (SoAction *action, SoNode *node)
static void callbackS (SoAction *action, SoNode *node)
static void getMatrixS (SoAction *action, SoNode *node)
static void handleEventS (SoAction *action, SoNode *node)
static void pickS (SoAction *action, SoNode *node)
static void rayPickS (SoAction *action, SoNode *node)
static void searchS (SoAction *action, SoNode *node)
static void writeS (SoAction *action, SoNode *node)
static void audioRenderS (SoAction *action, SoNode *node)
static void getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void cleanupClass (void)
static void initCopyDict (void)
static void addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void copyDone (void)
Static Public Member Functions inherited from SoBase
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void addName (SoBase *const base, const char *const name)
static void removeName (SoBase *const base, const char *const name)
static void incrementCurrentWriteCounter (void)
static void decrementCurrentWriteCounter (void)
static SoBase * getNamedBase (const SbName &name, SoType type)
static int getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool read (SoInput *input, SoBase *&base, SoType expectedtype)
static void setInstancePrefix (const SbString &c)
static void setTraceRefs (SbBool trace)
static SbBool getTraceRefs (void)
static SbBool connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool readRoute (SoInput *input)

  Public Attributes
SoMFInt32 markerIndex
Public Attributes inherited from SoPointSet
SoSFInt32 numPoints
Public Attributes inherited from SoNonIndexedShape
SoSFInt32 startIndex
Public Attributes inherited from SoVertexShape
SoSFNode vertexProperty

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoMarkerSet ()
Protected Member Functions inherited from SoPointSet
virtual ~SoPointSet ()
virtual void generatePrimitives (SoAction *action)
virtual void computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
virtual SbBool generateDefaultNormals (SoState *, SoNormalCache *nc)
virtual SbBool generateDefaultNormals (SoState *state, SoNormalBundle *bundle)
Protected Member Functions inherited from SoNonIndexedShape
SoNonIndexedShape (void)
virtual ~SoNonIndexedShape ()
void computeCoordBBox (SoAction *action, int numVertices, SbBox3f &box, SbVec3f &center)
void fixNumVerticesPointers (SoState *state, const int32_t *&start, const int32_t *&end, int32_t *dummyarray) const
Protected Member Functions inherited from SoVertexShape
SoVertexShape (void)
virtual ~SoVertexShape ()
virtual SbBool shouldGLRender (SoGLRenderAction *action)
void setNormalCache (SoState *const state, const int num, const SbVec3f *normals)
SoNormalCache * getNormalCache (void) const
SoNormalCache * generateAndReadLockNormalCache (SoState *const state)
void getVertexData (SoState *state, const SoCoordinateElement *&coords, const SbVec3f *&normals, const SbBool neednormals)
void readLockNormalCache (void)
void readUnlockNormalCache (void)
Protected Member Functions inherited from SoShape
SoShape (void)
virtual ~SoShape ()
float getComplexityValue (SoAction *action)
void beginSolidShape (SoGLRenderAction *action)
void endSolidShape (SoGLRenderAction *action)
void GLRenderBoundingBox (SoGLRenderAction *action)
SbBool shouldPrimitiveCount (SoGetPrimitiveCountAction *action)
SbBool shouldRayPick (SoRayPickAction *const action)
void computeObjectSpaceRay (SoRayPickAction *const action)
void computeObjectSpaceRay (SoRayPickAction *const action, const SbMatrix &matrix)
virtual SoDetail * createTriangleDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, const SoPrimitiveVertex *v3, SoPickedPoint *pp)
virtual SoDetail * createLineSegmentDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, SoPickedPoint *pp)
virtual SoDetail * createPointDetail (SoRayPickAction *action, const SoPrimitiveVertex *v, SoPickedPoint *pp)
void invokeTriangleCallbacks (SoAction *const action, const SoPrimitiveVertex *const v1, const SoPrimitiveVertex *const v2, const SoPrimitiveVertex *const v3)
void invokeLineSegmentCallbacks (SoAction *const action, const SoPrimitiveVertex *const v1, const SoPrimitiveVertex *const v2)
void invokePointCallbacks (SoAction *const action, const SoPrimitiveVertex *const v)
void beginShape (SoAction *const action, const TriangleShape shapetype, SoDetail *const detail=NULL)
void shapeVertex (const SoPrimitiveVertex *const v)
void endShape (void)
void generateVertex (SoPrimitiveVertex *const pv, const SbVec3f &point, const SbBool useTexFunc, const SoMultiTextureCoordinateElement *const tce, const float s, const float t, const SbVec3f &normal)
void generateVertex (SoPrimitiveVertex *const pv, const SbVec3f &point, const SbBool useTexFunc, const SoMultiTextureCoordinateElement *const tce, const float s, const float t, const float r, const SbVec3f &normal)
SbBool startVertexArray (SoGLRenderAction *action, const SoCoordinateElement *coords, const SbVec3f *pervertexnormals, const SbBool texpervertex, const SbBool colorpervertex)
void finishVertexArray (SoGLRenderAction *action, const SbBool vbo, const SbBool normpervertex, const SbBool texpervertex, const SbBool colorpervertex)
Protected Member Functions inherited from SoNode
SoNode (void)
virtual ~SoNode ()
virtual SbBool readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
SoFieldContainer (void)
virtual ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
SoBase (void)
virtual ~SoBase ()
virtual void destroy (void)
SbBool hasMultipleWriteRefs (void) const
SbBool writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void writeFooter (SoOutput *out) const
virtual const char * getFileFormatName (void) const
virtual SoNotRec createNotRec (void)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoPointSet
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNonIndexedShape
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoVertexShape
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoShape
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** getFieldDataPtr (void)
static void setNextActionMethodIndex (int index)
static int getNextActionMethodIndex (void)
static void incNextActionMethodIndex (void)
static void setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t getCurrentWriteCounter (void)
static void staticDataLock (void)
static void staticDataUnlock (void)

  Additional Inherited Members
Protected Types inherited from SoBase
enum BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId nextUniqueId = 1
static int nextActionMethodIndex = 0

Detailed Description

The SoMarkerSet class displays a set of 2D bitmap markers in 3D. This node uses the coordinates currently on the state (or in the vertexProperty field) in order. The numPoints field specifies the number of points in the set.

In addition to supplying the user with a set of standard markers to choose from, it is also possible to specify one's own bitmaps for markers.

This node class is an extension versus the original SGI Inventor v2.1 API. In addition to being a Coin extension, it is also present in TGS' Inventor implementation. (Note that TGS's implementation doesn't support the NONE markerIndex value.)

FILE FORMAT/DEFAULTS:

MarkerSet {
    vertexProperty NULL
    startIndex 0
    numPoints -1
    markerIndex 0
}

Since
    TGS Inventor 2.5

    Coin 1.0

Member Enumeration Documentation

  enum SoMarkerSet::MarkerType
Defines the different standard markers.

Constructor & Destructor Documentation

  SoMarkerSet::SoMarkerSet (void )
Constructor.

  SoMarkerSet::~SoMarkerSet () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoMarkerSet::getClassTypeId (void ) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoMarkerSet::getTypeId (void ) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoPointSet.

  const SoFieldData ** SoMarkerSet::getFieldDataPtr (void ) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoMarkerSet::getFieldData (void ) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoPointSet.

  void SoMarkerSet::initClass (void ) [static]

  void SoMarkerSet::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoPointSet.

  void SoMarkerSet::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoPointSet.

  int SoMarkerSet::getNumDefinedMarkers (void ) [static]
Returns the number of defined markers.

  void SoMarkerSet::addMarker (int idx, const SbVec2s & size, const unsigned char * bytes, SbBool isLSBFirst = TRUE, SbBool isUpToDown = TRUE) [static]
Replace the bitmap for the marker at idx with the representation given by size dimensions with the bitmap data at bytes. isLSBFirst and isUpToDown indicates how the bitmap data is ordered. Does nothing if markerIndex is NONE.

Here's a complete usage example which demonstrates how to set up a user specified marker from a character map. Note that the "multi colored" pixmap data is converted to a monochrome bitmap before being passed to addMarker() because addMarker() supports only bitmaps.

const int WIDTH = 18;
const int HEIGHT = 19;
const int BYTEWIDTH = (WIDTH + 7) / 2;
const char coin_marker[WIDTH * HEIGHT + 1] = {
  ".+                "
  "+@.+              "
  " .@#.+            "
  " +$@##.+          "
  "  .%@&##.+        "
  "  +$@&&*##.+      "
  "   .%@&&*=##.+    "
  "   +$@&&&&=-##.+  "
  "    .%@&&&&&-;#&+ "
  "    +$@&&&&&&=#.  "
  "     .%@&&&&*#.   "
  "     +$@&&&&#.    "
  "      .%@&@%@#.   "
  "      +$%@%.$@#.  "
  "       .%%. .$@#. "
  "       +$.   .$>#."
  "        +     .$. "
  "               .  "
  "                  " };
int byteidx = 0;
unsigned char bitmapbytes[BYTEWIDTH * HEIGHT];
for (int h = 0; h < HEIGHT; h++) {
  unsigned char bits = 0;
  for (int w = 0; w < WIDTH; w++) {
    if (coin_marker[(h * WIDTH) + w] != ' ') { bits |= (0x80 >> (w % 8)); }
    if ((((w + 1) % 8) == 0) || (w == WIDTH - 1)) {
      bitmapbytes[byteidx++] = bits;
      bits = 0;
    }
  }
}
int MYAPP_ARROW_IDX = SoMarkerSet::getNumDefinedMarkers(); // add at end
SoMarkerSet::addMarker(MYAPP_ARROW_IDX, SbVec2s(WIDTH, HEIGHT),
                       bitmapbytes, FALSE, TRUE);

This will provide you with an index given by MYAPP_ARROW_IDX which can be used in SoMarkerSet::markerIndex to display the new marker.

  SbBool SoMarkerSet::getMarker (int idx, SbVec2s & size, const unsigned char *& bytes, SbBool & isLSBFirst) [static]
Returns data for marker at idx in the size, bytes and isLSBFirst parameters.

If no marker is defined for given idx, or SoMarkerSet::markerIndex is NONE (not removable), FALSE is returned. If everything is OK, TRUE is returned.

  SbBool SoMarkerSet::removeMarker (int idx) [static]
Removes marker at idx.

If no marker is defined for given idx, or SoMarkerSet::markerIndex is NONE (not removable), FALSE is returned. If everything is OK, TRUE is returned.

  SbBool SoMarkerSet::isMarkerBitSet (int idx, int bitNumber) [static]
Not supported in Coin. Should probably not have been part of the public Open Inventor API.

Member Data Documentation

  SoMFInt32 SoMarkerSet::markerIndex
Contains the set of index markers to display, defaults to 0 (CROSS_5_5). The special value NONE renders nothing for that marker.

Author

Generated automatically by Doxygen for Coin from the source code.